/*
 *  KSambaSubRecord.h
 *  KDataStructure
 *
 *  Created by Adam Cox on 3/25/10.
 *  Copyright 2010 Karlsruhe Institute of Technology. All rights reserved.
 *
 */

#ifndef __KSAMBASUBRECORD_H__
#define __KSAMBASUBRECORD_H__

#include "KSubRecord.h"
#include <string>
#include <cstdlib>

using namespace std;

class KSambaSubRecord : public KSubRecord { 

public:
  //Constructors
  KSambaSubRecord(void);
	KSambaSubRecord(const KSambaSubRecord &aRec);
	KSambaSubRecord& operator=(const KSambaSubRecord &aRec);
  virtual ~KSambaSubRecord(void);
	virtual void Clear(Option_t *opt = "C");
	Bool_t IsSame(const KSambaSubRecord &aRec, Bool_t bPrint = false) const;
	Bool_t operator==(const KSambaSubRecord &aRec) const { return IsSame(aRec,false); }
	Bool_t operator!=(const KSambaSubRecord &aRec) const { return !(*this==aRec); }
	virtual void Compact(void);
	
	//getters
	Int_t GetSambaEventNumber(void) const {return fSambaEventNumber;}
	Int_t GetSambaDAQNumber(void) const {return fSambaDAQNumber;}
	
	//setters
	void SetSambaEventNumber(Int_t aWord) {fSambaEventNumber = aWord;}
	void SetSambaDAQNumber(Int_t aWord) {fSambaDAQNumber = aWord;}
	
private:
	Int_t fSambaEventNumber;  //the event number according to the Samba NTP record
	Int_t fSambaDAQNumber; //this is found in the name.. a=1, b=2, c=3, etc..
	
	
	//private methods
	void InitializeMembers(void);
	void CopyLocalMembers(const KSambaSubRecord &aRec);
	
  ClassDef(KSambaSubRecord,1);
};


#endif // __KSAMBASUBRECORD_H__
