/*
 *  KSingleBoloSubRecord.h
 *  KDataStructure
 *
 *  Created by Adam Cox on 3/25/10.
 *  Copyright 2010 Karlsruhe Institute of Technology. All rights reserved.
 *
 */

#ifndef __KSINGLEBOLOSUBRECORD_H__
#define __KSINGLEBOLOSUBRECORD_H__

#include "KSubRecord.h"
#include <string>
#include "TRef.h"

#include "KSambaSubRecord.h"

using namespace std;

class KSingleBoloSubRecord : public KSubRecord {

public:
  //Constructors
  KSingleBoloSubRecord(void);
	KSingleBoloSubRecord(const KSingleBoloSubRecord &aRec);
	KSingleBoloSubRecord& operator=(const KSingleBoloSubRecord &aRec);
  virtual ~KSingleBoloSubRecord(void);
	virtual void Clear(Option_t *opt = "C");
	Bool_t IsSame(const KSingleBoloSubRecord &aRec, Bool_t bPrint = false) const;
	Bool_t operator==(const KSingleBoloSubRecord &aRec) const { return IsSame(aRec,false); }
	Bool_t operator!=(const KSingleBoloSubRecord &aRec) const { return !(*this==aRec); }
	virtual void Compact(void);
	
	//getters
	Int_t GetDetectorNumber(void) const {return fDetectorNumber;}
	Double32_t GetEnergyHeat(void) const {return fEnergyHeat;}

	KSambaSubRecord* GetSambaRecord() const {return (KSambaSubRecord*)fSambaRecord.GetObject();}


	//setters
	void SetDetectorNumber(Int_t aWord) {fDetectorNumber = aWord;}
	void SetEnergyHeat(Double32_t aWord) {fEnergyHeat = aWord;}

	void SetSambaRecord(KSambaSubRecord* aRec){fSambaRecord = aRec;}


private:
	Int_t fDetectorNumber;  
	Double32_t fEnergyHeat; //independent of event category. based upon the heat pulse height.
		
	TRef fSambaRecord;  //points to the samba record associated with this event.

	
	//private methods
  void InitializeMembers(void);
	void CopyLocalMembers(const KSingleBoloSubRecord &aRec);
	
  ClassDef(KSingleBoloSubRecord,1);
};


#endif // __KSINGLEBOLOSUBRECORD_H__

